Unit AMZ4R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMZ4R(var A :Array of Real; N :Integer; NC :Integer;
                var B :Array of Real); 
implementation

procedure AMZ4R(var A :Array of Real; N :Integer; NC :Integer;
                var B :Array of Real);
var
K,NCP1,KK,KP1,J,LL,I,L :Integer;
const
ZERO :Real = 0.0E0;
label
_1,_2,_3,_4,_5,_6,_7;
begin
K := 1;
NCP1 := NC+1;
for I:=1 to NCP1 do
 begin
  KK := NCP1;
  KP1 := K+1;
  for J:=1 to K do
   begin
    LL := KP1-J;
    B[(I-1)+(KK-1)*N] := A[(I-1)+(LL-1)*N];
    KK := KK-1;
_1:
   end;
  K := K+1;
_2:
 end;
if ( N = 1 ) 
 then goto _7;
KK := 2;
for I:=K to N do
 begin
  LL := KK;
  for J:=1 to NCP1 do
   begin
    B[(I-1)+(J-1)*N] := A[(I-1)+(LL-1)*N];
    LL := LL+1;
_3:
   end;
  KK := KK+1;
_4:
 end;
if ( NC = 0 ) 
 then goto _7;
K := NC;
L := K;
for I:=1 to K do
 begin
  for J:=1 to L do
   begin
    B[(I-1)+(J-1)*N] := ZERO;
_5:
   end;
  L := L-1;
_6:
 end;
_7:
end;

end.
